package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Account;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: AccountType
// UnionValue: SyntheticLedger

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SyntheticLedger")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SyntheticLedger implements Account {
	public final AccountType type = AccountType.SYNTHETIC_LEDGER;
	private Url url;
	private PartitionSyntheticLedger[] sequence;

    //
	public Url getUrl() {
	    return url;
	}
	public void setUrl(final Url value) {
	    this.url = value;
	}

	public SyntheticLedger url(final Url value) {
	    setUrl(value);
	    return this;
	}
	public SyntheticLedger url(final String value) {
	    setUrl(Url.toAccURL(value));
	    return this;
	}
	public PartitionSyntheticLedger[] getSequence() {
	    return sequence;
	}
	public void setSequence(final PartitionSyntheticLedger[] value) {
	    this.sequence = value;
	}

	public SyntheticLedger sequence(final PartitionSyntheticLedger[] value) {
	    setSequence(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.url == null)) {
            marshaller.writeUrl(2, this.url);
        }
        if (!(this.sequence == null)) {
            marshaller.writeValue(3, sequence);
        }
        return marshaller.array();
    }
}
